/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*- */

#include "framecpp/Common/FrameBufferInterface.hh"

namespace FrameCPP
{
  namespace Common
  {
    /// \brief The default size for buffered input and output.
    const FrameBufferInterface::buffer_size_type
    FrameBufferInterface::M_BUFFER_SIZE_DEFAULT = 256 * 1024; // 256K

    FrameBufferInterface::
    FrameBufferInterface( )
      : m_auto_delete( false )
    {
    }

    FrameBufferInterface::
    ~FrameBufferInterface( )
    {
    }

    void FrameBufferInterface::
    FilterAdd( FrameCPP::Common::StreamFilter* Filter )
    {
      m_filters.push_back( Filter );
    }

    void FrameBufferInterface::
    FilterRemove( FrameCPP::Common::StreamFilter* Filter )
    {
      m_filters.remove( Filter );
    }

    void FrameBufferInterface::
    FilterBuffer( const char* Begin, const char* End )
    {
      if ( ( Begin == (const char*)0 )
	   || ( Begin == End ) )
      {
	return;
      }

      for( filters_type::const_iterator
	     cur = m_filters.begin( ),
	     last = m_filters.end( );
	   cur != last;
	   ++cur )
      {
	if ( *cur )
	{
	  INT_8U length = End - Begin;

	  (*cur)->pubfilter( Begin, length * sizeof( char ) );
	}
      }
    }

  }
}
